import bpy
from math import pi, sin, cos

# http://sinestesia.co/blog/tutorials/python-2d-grid/
# https://blender3d.com.ua/meshi-s-pomoshchyu-python-i-blender-2d-setka/

# Settings
name = "Gridtastic"
rows = 5
columns = 10
size = 0.5

# Utility functions
def vert(column, row):
    """ Create a single vert """
    
    return (column * size, row * size, 0)

def face(column, row):
    """ Create a single face """
    
    return (column * rows + row,
            (column + 1) * rows + row,
            (column + 1) * rows + 1 + row,
            column * rows + 1 + row)

class My_Operator(bpy.types.Operator):
    bl_idname = "view3d.create_2d_grid"
    bl_label = "Simple operator"
    bl_description = "Create Mitsubishi Logo"

    def execute(self, context):

        # verts = [(0, 0, 0)]
        # verts = [(x, 0, 0) for x in range(columns)]
        # verts = [(x, y, 0) for x in range(columns) for y in range(rows)]
        # faces = [(0, 5, 6, 1)]

        # Looping to create the grid
        #verts = [vert(x, y) for x in range(columns) for y in range(rows)]
        #faces = [face(x, y) for x in range(columns - 1) for y in range(rows - 1)]

        r1 = 1
        r2 = r1 * sin(60 * pi / 180) * 2

        verts = []
        faces = []

        x0 = 0
        y0 = 0
        verts.append((x0, y0, 0))

        face_index = 0
        for main in range(90, 360, 120):
            low_offset = main - 30
            high_offset = main + 30
            x1 = round(r1 * cos(low_offset * pi / 180), 3)
            y1 = round(r1 * sin(low_offset * pi / 180), 3)
            x2 = round(r2 * cos(main * pi / 180), 3)
            y2 = round(r2 * sin(main * pi / 180), 3)
            x3 = round(r1 * cos(high_offset * pi / 180), 3)
            y3 =round( r1 * sin(high_offset * pi / 180), 3)
            verts.append((x1, y1, 0))
            verts.append((x2, y2, 0))
            verts.append((x3, y3, 0))
            
            f0 = 0
            face_index += 1
            f1 = face_index
            face_index += 1
            f2 = face_index
            face_index += 1
            f3 = face_index
            faces.append((f0, f1, f2, f3))

        # x2 = 0
        # y2 = r2

        # angle += 60
        # x3 = r1 * cos(angle * pi / 180)
        # y3 = r1 * sin(angle * pi / 180)

        # verts = [(x0, y0, 0), (x1, y1, 0), (x2, y2, 0), (x3, y3, 0)]
        # faces = [(0, 1, 2, 3)]

        # for x in range(columns - 1):
        #     print(x * rows)
        #     print((x + 1) * rows)

        # Create Mesh Datablock
        mesh = bpy.data.meshes.new(name)
        mesh.from_pydata(verts, [], faces)

        # Create Object and link to scene
        obj = bpy.data.objects.new(name, mesh)
        bpy.context.scene.collection.objects.link(obj)

        # Select the object
        bpy.context.view_layer.objects.active = obj
        bpy.context.active_object.select_set(state=True)

        return {'FINISHED'}
